function H = hilb_local(n) 
%  hilb_local: Hilbert matrix of order n (not from MATLAB) 
%  hilb_local(n) constructs the n by n matrix with elements 1/(i+j-1). 
%  This is one of the most famous examples of a matrix which is 
%  nonsingular, but which is very badly conditioned. 
H = zeros(n); 
for i = 1:n 
   for j = 1:n 
     H(i,j) = 1/(i+j-1); 
   end 
end