function sol = nlode_all(which_ode, e, A, nr_points) 
%  nlode_all: boundary-value solver using bvp4c 
%  which_ ode = 1  y'' + 2 y' + e exp(y) = 0, y(0) = y(1) = 0 
%             = 2  e y'' + 2 y' + exp(y) = 0 , y(0) = y(1) = 0 
%  A = the initial guess is  y = 4 A x (1 - x) 
%  nr_points = number of equally spaced points in initial guess 
x = linspace(0, 1, nr_points); 
solinit = bvpinit(x, @nlode_y_ic); 
sol = bvp4c(@nlode, @nlode_bc, solinit); 
xpt = linspace(0, 1, 101); 
Ypt = deval(sol, xpt); 
plot(xpt, Ypt(1,:), xpt, Ypt(2,:), 'r') 
%%%%% nested functions follow 
   function y_ic = nlode_y_ic(x) 
   y_ic = [4*A*x.*(1 - x); 4*A*(1-2*x)]; 
   end 
   function yp = nlode(x, y) 
   if which_ode == 1 
     yp = [y(2); -e*exp(y(1))-2*y(2)]; 
   else 
     yp = [y(2); -(exp(y(1))+2*y(2))/e]; 
   end 
   end 
   function bc = nlode_bc(ya, yb) 
   bc = [ya(1); yb(1)]; 
   end 
end