% modified from the MATLAB function life which is
% Copyright 1984-2004 The MathWorks, Inc.
iseed = 3343;     % modify seed to obtain different cells                %  1
rand('state', iseed);                                                    %  2
M = avifile('life_movie.avi');                                           %  3
m = 26;                                                                  %  4
max_nr_iter = 10000;                                                     %  5
X = sparse(m, m);                                                        %  6
p = -1:1;                                                                %  7
for count = 1:15                                                         %  8
    kx = floor((m - 4)*rand(1)) + 2;                                     %  9
    ky = floor((m - 4)*rand(1)) + 2;                                     % 10
    X(kx+p,ky+p) = (rand(3) > 0.5);                                      % 11
end;                                                                     % 12
[i, j] = find(X);                                                        % 13
figure(gcf);                                                             % 14
nr_iter = 0;                                                             % 15
plothandle = plot(i, j, '.', 'Color', 'Red', 'MarkerSize', 12);          % 16
title(['# iter = ', num2str(nr_iter)])                                   % 16
axis([0 m+1 0 m+1]);                                                     % 17
drawnow                                                                  % 18
F = getframe(gcf);                                                       % 19
M = addframe(M,  F);                                                     % 20
file_name = ['life_movie', num2str(nr_iter, '%06d'), '.jpg'];            % 22
saveas(gcf, file_name);                                                  % 21
Xprev = X;                                                               % 22
Xprev2 = X;                                                              % 23
n = [m 1:m-1];                                                           % 24
e = [2:m 1];                                                             % 25
s = [2:m 1];                                                             % 26
w = [m 1:m-1];                                                           % 27
while true                                                               % 28
    N = X(n,:) + X(s,:) + X(:,e) + X(:,w) + X(n,e) + X(n,w) + ...
       X(s,e) + X(s,w);                                                  % 29
    X = (X & (N == 2)) | (N == 3);                                       % 30
    [i,j] = find(X);                                                     % 31
    nr_iter = nr_iter + 1;                                               % 32
    set(plothandle, 'xdata', i, 'ydata', j)                              % 33
    title(['# iter = ', num2str(nr_iter)])                               % 34
    drawnow                                                              % 35
    F = getframe(gcf);                                                   % 36
    M = addframe(M,  F);                                                 % 37
    file_name = ['life_movie', num2str(nr_iter, '%06d'), '.jpg'];        % 38
    saveas(gcf, file_name);                                              % 39
    if X == Xprev2                                                       % 40
       break                                                             % 41
    else                                                                 % 42
       Xprev2 = Xprev;                                                   % 43
       Xprev = X;                                                        % 44
    end                                                                  % 45
    if nr_iter > max_nr_iter                                             % 46
       disp('EXIT - MAXIMUM NUMBER OF ITERATIONS EXCEEDED')              % 47
       break                                                             % 48
    end                                                                  % 49
end                                                                      % 50
M = close(M);                                                            % 51
